Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/src/ICE/icedyn_adv_umx.F90
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/src/ICE/icedyn_adv_umx.F90	(revision 10417)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/src/ICE/icedyn_adv_umx.F90	(revision 10419)
@@ -178,112 +294,702 @@
       !! ** Action : - pt  the after advective tracer
       !!----------------------------------------------------------------------
-      INTEGER                         , INTENT(in   ) ::   k_order        ! order of the ULTIMATE scheme
-      INTEGER                         , INTENT(in   ) ::   kt             ! number of iteration
-      INTEGER                         , INTENT(in   ) ::   ipl            ! third dimension of tracer array
-      REAL(wp)                        , INTENT(in   ) ::   pdt            ! tracer time-step
-      REAL(wp), DIMENSION(jpi,jpj)    , INTENT(in   ) ::   puc  , pvc     ! 2 ice velocity components => u*e2
-      REAL(wp), DIMENSION(jpi,jpj)    , INTENT(in   ) ::   pubox, pvbox   ! upstream velocity
-      REAL(wp), DIMENSION(jpi,jpj,ipl), INTENT(inout) ::   ptc            ! tracer content field
+      REAL(wp)                    , INTENT(in   )           ::   pamsk          ! advection of concentration (1) or other tracers (0)
+      INTEGER                     , INTENT(in   )           ::   kn_umx         ! order of the scheme (1-5=UM or 20=CEN2)
+      INTEGER                     , INTENT(in   )           ::   jt             ! number of sub-iteration
+      INTEGER                     , INTENT(in   )           ::   kt             ! number of iteration
+      REAL(wp)                    , INTENT(in   )           ::   pdt            ! tracer time-step
+      REAL(wp), DIMENSION(:,:  ), INTENT(in   )           ::   pu   , pv      ! 2 ice velocity components => u*e2
+      REAL(wp), DIMENSION(:,:,:), INTENT(in   )           ::   puc  , pvc     ! 2 ice velocity components => u*e2 or u*a*e2u
+      REAL(wp), DIMENSION(:,:  ), INTENT(in   )           ::   pubox, pvbox   ! upstream velocity
+      REAL(wp), DIMENSION(:,:,:), INTENT(inout)           ::   pt             ! tracer field
+      REAL(wp), DIMENSION(:,:,:), INTENT(inout)           ::   ptc            ! tracer content field
+      REAL(wp), DIMENSION(jpi,jpj,jpl), INTENT(  out), OPTIONAL ::   pua_ho, pva_ho ! high order u*a fluxes
       !
       INTEGER  ::   ji, jj, jl       ! dummy loop indices  
-
       REAL(wp) ::   ztra             ! local scalar
-      REAL(wp), DIMENSION(jpi,jpj,ipl) ::   zfu_ups, zfu_ho, zt_u, zt_ups
-      REAL(wp), DIMENSION(jpi,jpj,ipl) ::   zfv_ups, zfv_ho, zt_v, ztrd
-
-      DO jl = 1, ipl
-      !!----------------------------------------------------------------------
-      !
-      !  upstream advection with initial mass fluxes & intermediate update
-      ! --------------------------------------------------------------------
-      DO jj = 1, jpjm1         ! upstream tracer flux in the i and j direction
-         DO ji = 1, fs_jpim1   ! vector opt.
-            zfu_ups(ji,jj,jl) = MAX( puc(ji,jj), 0._wp ) * ptc(ji,jj,jl) + MIN( puc(ji,jj), 0._wp ) * ptc(ji+1,jj,jl)
-            zfv_ups(ji,jj,jl) = MAX( pvc(ji,jj), 0._wp ) * ptc(ji,jj,jl) + MIN( pvc(ji,jj), 0._wp ) * ptc(ji,jj+1,jl)
+      INTEGER  ::   kn_limiter = 1   ! 1=nonosc ; 2=superbee ; 3=h3(rachid)
+      REAL(wp), DIMENSION(jpi,jpj,jpl) ::   zfu_ho , zfv_ho , zt_u, zt_v, zpt
+      REAL(wp), DIMENSION(jpi,jpj,jpl) ::   zfu_ups, zfv_ups, zt_ups   ! only for nonosc 
+      !!----------------------------------------------------------------------
+      !
+      !  upstream (_ups) advection with initial mass fluxes
+      ! ---------------------------------------------------
+
+      IF( ll_gurvan .AND. pamsk==0. ) THEN
+         DO jl = 1, jpl
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1
+                  pt(ji,jj,jl) = ( pt (ji,jj,jl) + pt(ji,jj,jl) * pdt * ( pu(ji,jj) - pu(ji-1,jj) ) * r1_e1e2t(ji,jj)     &
+                     &                           + pt(ji,jj,jl) * pdt * ( pv(ji,jj) - pv(ji,jj-1) ) * r1_e1e2t(ji,jj) )   &
+                     &           * tmask(ji,jj,1)
+               END DO
+            END DO
+         END DO
+         CALL lbc_lnk( 'icedyn_adv_umx', pt, 'T', 1. )
+      ENDIF
+
+      
+      IF( .NOT. ll_upsxy ) THEN
+
+         ! fluxes in both x-y directions
+         DO jl = 1, jpl
+            DO jj = 1, jpjm1
+               DO ji = 1, fs_jpim1
+                  IF( ll_clem ) THEN
+                     zfu_ups(ji,jj,jl) = MAX( pu(ji,jj), 0._wp ) * pt(ji,jj,jl) + MIN( pu(ji,jj), 0._wp ) * pt(ji+1,jj,jl)
+                     zfv_ups(ji,jj,jl) = MAX( pv(ji,jj), 0._wp ) * pt(ji,jj,jl) + MIN( pv(ji,jj), 0._wp ) * pt(ji,jj+1,jl)
+                  ELSE
+                     zfu_ups(ji,jj,jl) = MAX( puc(ji,jj,jl), 0._wp ) * pt(ji,jj,jl) + MIN( puc(ji,jj,jl), 0._wp ) * pt(ji+1,jj,jl)
+                     zfv_ups(ji,jj,jl) = MAX( pvc(ji,jj,jl), 0._wp ) * pt(ji,jj,jl) + MIN( pvc(ji,jj,jl), 0._wp ) * pt(ji,jj+1,jl)
+                  ENDIF
+               END DO
+            END DO
+         END DO
+
+      ELSE
+         !
+         IF( MOD( (kt - 1) / nn_fsbc , 2 ) ==  MOD( (jt - 1) , 2 ) ) THEN   !==  odd ice time step:  adv_x then adv_y  ==!
+            ! flux in x-direction
+            DO jl = 1, jpl
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1
+                     IF( ll_clem ) THEN
+                        zfu_ups(ji,jj,jl) = MAX( pu(ji,jj), 0._wp ) * pt(ji,jj,jl) + MIN( pu(ji,jj), 0._wp ) * pt(ji+1,jj,jl)
+                     ELSE
+                        zfu_ups(ji,jj,jl) = MAX( puc(ji,jj,jl), 0._wp ) * pt(ji,jj,jl) + MIN( puc(ji,jj,jl), 0._wp ) * pt(ji+1,jj,jl)
+                     ENDIF
+                  END DO
+               END DO
+            END DO
+            
+            ! first guess of tracer content from u-flux
+            DO jl = 1, jpl
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     IF( ll_clem ) THEN
+                        IF( ll_gurvan ) THEN
+                           zpt(ji,jj,jl) = ( pt(ji,jj,jl) - ( zfu_ups(ji,jj,jl) - zfu_ups(ji-1,jj,jl) ) * pdt * r1_e1e2t(ji,jj) ) * tmask(ji,jj,1)
+                        ELSE
+                           zpt(ji,jj,jl) = ( pt(ji,jj,jl) - ( zfu_ups(ji,jj,jl) - zfu_ups(ji-1,jj,jl) ) * pdt * r1_e1e2t(ji,jj)  &
+                              &            + pt(ji,jj,jl) * pdt * ( pu(ji,jj) - pu(ji-1,jj) ) * r1_e1e2t(ji,jj) * (1.-pamsk) &
+                              &            ) * tmask(ji,jj,1)
+                        ENDIF
+                     ELSE
+                        zpt(ji,jj,jl) = ( ptc(ji,jj,jl) - ( zfu_ups(ji,jj,jl) - zfu_ups(ji-1,jj,jl) ) * pdt * r1_e1e2t(ji,jj) ) &
+                           &         * tmask(ji,jj,1)
+                     ENDIF
+                     !!                  IF( ji==26 .AND. jj==86) THEN
+                     !!                     WRITE(numout,*) '************************'
+                     !!                     WRITE(numout,*) 'zpt upstream',zpt(ji,jj)
+                     !!                  ENDIF
+                  END DO
+               END DO
+            END DO
+            CALL lbc_lnk( 'icedyn_adv_umx', zpt, 'T', 1. )
+            !
+            ! flux in y-direction
+            DO jl = 1, jpl
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1
+                     IF( ll_clem ) THEN
+                        zfv_ups(ji,jj,jl) = MAX( pv(ji,jj), 0._wp ) * zpt(ji,jj,jl) + MIN( pv(ji,jj), 0._wp ) * zpt(ji,jj+1,jl)
+                     ELSE
+                        zfv_ups(ji,jj,jl) = MAX( pvc(ji,jj,jl), 0._wp ) * zpt(ji,jj,jl) + MIN( pvc(ji,jj,jl), 0._wp ) * zpt(ji,jj+1,jl)
+                     ENDIF
+                  END DO
+               END DO
+            END DO
+         !
+         ELSE                                                               !==  even ice time step:  adv_y then adv_x  ==!
+            ! flux in y-direction
+            DO jl = 1, jpl
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1
+                     IF( ll_clem ) THEN
+                        zfv_ups(ji,jj,jl) = MAX( pv(ji,jj), 0._wp ) * pt(ji,jj,jl) + MIN( pv(ji,jj), 0._wp ) * pt(ji,jj+1,jl)
+                     ELSE
+                        zfv_ups(ji,jj,jl) = MAX( pvc(ji,jj,jl), 0._wp ) * pt(ji,jj,jl) + MIN( pvc(ji,jj,jl), 0._wp ) * pt(ji,jj+1,jl)
+                     ENDIF
+                  END DO
+               END DO
+            END DO
+
+            ! first guess of tracer content from v-flux
+            DO jl = 1, jpl
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     IF( ll_clem ) THEN
+                        IF( ll_gurvan ) THEN
+                           zpt(ji,jj,jl) = ( pt(ji,jj,jl) - ( zfv_ups(ji,jj,jl) - zfv_ups(ji,jj-1,jl) ) * pdt * r1_e1e2t(ji,jj) ) * tmask(ji,jj,1)
+                        ELSE
+                           zpt(ji,jj,jl) = ( pt(ji,jj,jl) - ( zfv_ups(ji,jj,jl) - zfv_ups(ji,jj-1,jl) ) * pdt * r1_e1e2t(ji,jj) &
+                              &            + pt(ji,jj,jl) * pdt * ( pv(ji,jj) - pv(ji,jj-1) ) * r1_e1e2t(ji,jj) * (1.-pamsk) ) &
+                              &            * tmask(ji,jj,1)
+                        ENDIF
+                     ELSE
+                        zpt(ji,jj,jl) = ( ptc(ji,jj,jl) - ( zfv_ups(ji,jj,jl) - zfv_ups(ji,jj-1,jl) ) * pdt * r1_e1e2t(ji,jj) ) &
+                           &            * tmask(ji,jj,1)
+                     ENDIF
+                     !!                  IF( ji==26 .AND. jj==86) THEN
+                     !!                     WRITE(numout,*) '************************'
+                     !!                     WRITE(numout,*) 'zpt upstream',zpt(ji,jj)
+                     !!                  ENDIF
+                  END DO
+               END DO
+            END DO
+            CALL lbc_lnk( 'icedyn_adv_umx', zpt, 'T', 1. )
+            !
+            ! flux in x-direction
+            DO jl = 1, jpl
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1
+                     IF( ll_clem ) THEN
+                        zfu_ups(ji,jj,jl) = MAX( pu(ji,jj), 0._wp ) * zpt(ji,jj,jl) + MIN( pu(ji,jj), 0._wp ) * zpt(ji+1,jj,jl)
+                     ELSE
+                        zfu_ups(ji,jj,jl) = MAX( puc(ji,jj,jl), 0._wp ) * zpt(ji,jj,jl) + MIN( puc(ji,jj,jl), 0._wp ) * zpt(ji+1,jj,jl)
+                     ENDIF
+                  END DO
+               END DO
+            END DO
+            !
+         ENDIF
+         
+      ENDIF
+
+      IF( ll_clem .AND. kn_limiter /= 1 )  &
+         & CALL ctl_stop( 'STOP', 'icedyn_adv_umx: ll_clem incompatible with limiters other than nonosc' )
+
+      IF( ll_zeroup2 ) THEN
+         DO jl = 1, jpl
+            DO jj = 1, jpjm1
+               DO ji = 1, fs_jpim1   ! vector opt.
+                  IF( amaxu(ji,jj,jl) == 0._wp )   zfu_ups(ji,jj,jl) = 0._wp
+                  IF( amaxv(ji,jj,jl) == 0._wp )   zfv_ups(ji,jj,jl) = 0._wp
+               END DO
+            END DO
+         END DO
+      ENDIF
+
+      ! guess after content field with upstream scheme
+      DO jl = 1, jpl
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1
+               ztra          = - (   zfu_ups(ji,jj,jl) - zfu_ups(ji-1,jj  ,jl)   &
+                  &                + zfv_ups(ji,jj,jl) - zfv_ups(ji  ,jj-1,jl) ) * r1_e1e2t(ji,jj)
+               IF( ll_clem ) THEN
+                  IF( ll_gurvan ) THEN
+                     zt_ups(ji,jj,jl) = ( pt (ji,jj,jl) + pdt * ztra ) * tmask(ji,jj,1)
+                  ELSE
+                     zt_ups(ji,jj,jl) = ( pt (ji,jj,jl) + pdt * ztra + ( pt(ji,jj,jl) * pdt * ( pu(ji,jj) - pu(ji-1,jj) )   &
+                        &                                            +   pt(ji,jj,jl) * pdt * ( pv(ji,jj) - pv(ji,jj-1) ) ) &
+                        &                                              * r1_e1e2t(ji,jj) * (1.-pamsk) ) * tmask(ji,jj,1)
+                  ENDIF
+               ELSE
+                  zt_ups(ji,jj,jl) = ( ptc(ji,jj,jl) + pdt * ztra ) * tmask(ji,jj,1)
+               ENDIF
+               !!            IF( ji==26 .AND. jj==86) THEN
+               !!               WRITE(numout,*) '**************************'
+               !!               WRITE(numout,*) 'zt upstream',zt_ups(ji,jj)
+               !!            ENDIF
+            END DO
          END DO
       END DO
-      
-         DO jj = 2, jpjm1            ! total intermediate advective trends
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               ztra = - (   zfu_ups(ji,jj,jl) - zfu_ups(ji-1,jj  ,jl)   &
-                  &       + zfv_ups(ji,jj,jl) - zfv_ups(ji  ,jj-1,jl)   ) * r1_e1e2t(ji,jj)
-            !
-               ztrd(ji,jj,jl) =                         ztra                         ! upstream trend [ -div(uh) or -div(uhT) ]  
-               zt_ups (ji,jj,jl) = ( ptc(ji,jj,jl) + pdt * ztra ) * tmask(ji,jj,1)   ! guess after content field with monotonic scheme
-            END DO
-         END DO
-      END DO
-      
+      CALL lbc_lnk( 'icedyn_adv_umx', zt_ups, 'T', 1. )
+
       ! High order (_ho) fluxes 
       ! -----------------------
-      SELECT CASE( k_order )
-      CASE ( 20 )                          ! centered second order
-         DO jl = 1, ipl
+      SELECT CASE( kn_umx )
+         !
+      CASE ( 20 )                          !== centered second order ==!
+         !
+         CALL cen2( pamsk, kn_limiter, jt, kt, pdt, pt, pu, pv, puc, pvc, ptc, zfu_ho, zfv_ho,  &
+            &       zt_ups, zfu_ups, zfv_ups )
+         !
+      CASE ( 1:5 )                         !== 1st to 5th order ULTIMATE-MACHO scheme ==!
+         !
+         CALL macho( pamsk, kn_limiter, kn_umx, jt, kt, pdt, pt, pu, pv, puc, pvc, pubox, pvbox, ptc, zt_u, zt_v, zfu_ho, zfv_ho,  &
+            &        zt_ups, zfu_ups, zfv_ups )
+         !
+      END SELECT
+
+      IF( ll_thickness ) THEN
+         ! final trend with corrected fluxes
+         ! ------------------------------------
+         DO jl = 1, jpl
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1
+                  IF( ll_gurvan ) THEN
+                     ztra       = - ( zfu_ho(ji,jj,jl) - zfu_ho(ji-1,jj,jl) + zfv_ho(ji,jj,jl) - zfv_ho(ji,jj-1,jl) ) * r1_e1e2t(ji,jj) 
+                  ELSE
+                     ztra       = ( - ( zfu_ho(ji,jj,jl) - zfu_ho(ji-1,jj,jl) + zfv_ho(ji,jj,jl) - zfv_ho(ji,jj-1,jl) )  & 
+                        &           + ( pt(ji,jj,jl) * ( pu(ji,jj) - pu(ji-1,jj) ) * (1.-pamsk) ) &
+                        &           + ( pt(ji,jj,jl) * ( pv(ji,jj) - pv(ji,jj-1) ) * (1.-pamsk) ) ) * r1_e1e2t(ji,jj)
+                  ENDIF
+                  pt(ji,jj,jl) = ( pt(ji,jj,jl) + pdt * ztra ) * tmask(ji,jj,1)
+                  
+                  IF( pt(ji,jj,jl) < -epsi20 ) THEN
+                     WRITE(numout,*) 'T<0 ',pt(ji,jj,jl)
+                  ENDIF
+                  
+                  IF( pt(ji,jj,jl) < 0._wp .AND. pt(ji,jj,jl) >= -epsi20 )   pt(ji,jj,jl) = 0._wp
+                  
+                  !!               IF( ji==26 .AND. jj==86) THEN
+                  !!                  WRITE(numout,*) 'zt high order',pt(ji,jj)
+                  !!               ENDIF
+               END DO
+            END DO
+         END DO
+         CALL lbc_lnk( 'icedyn_adv_umx', pt, 'T',  1. )
+      ENDIF
+   
+      ! Rachid trick
+      ! ------------
+      IF( ll_clem ) THEN
+         IF( pamsk == 0. ) THEN
+            DO jl = 1, jpl
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1
+                     IF( ABS( puc(ji,jj,jl) ) > 0._wp .AND. ABS( pu(ji,jj) ) > 0._wp ) THEN
+                        zfu_ho (ji,jj,jl) = zfu_ho (ji,jj,jl) * puc(ji,jj,jl) / pu(ji,jj)
+                        zfu_ups(ji,jj,jl) = zfu_ups(ji,jj,jl) * puc(ji,jj,jl) / pu(ji,jj)
+                     ELSE
+                        zfu_ho (ji,jj,jl) = 0._wp
+                        zfu_ups(ji,jj,jl) = 0._wp
+                     ENDIF
+                     !
+                     IF( ABS( pvc(ji,jj,jl) ) > 0._wp .AND. ABS( pv(ji,jj) ) > 0._wp ) THEN
+                        zfv_ho (ji,jj,jl) = zfv_ho (ji,jj,jl) * pvc(ji,jj,jl) / pv(ji,jj)
+                        zfv_ups(ji,jj,jl) = zfv_ups(ji,jj,jl) * pvc(ji,jj,jl) / pv(ji,jj)
+                     ELSE
+                        zfv_ho (ji,jj,jl) = 0._wp  
+                        zfv_ups(ji,jj,jl) = 0._wp  
+                     ENDIF
+                  END DO
+               END DO
+            END DO
+         ENDIF
+      ENDIF
+
+      IF( ll_zeroup5 ) THEN
+         DO jl = 1, jpl
+            DO jj = 2, jpjm1
+               DO ji = 2, fs_jpim1   ! vector opt.
+                  zpt(ji,jj,jl) = ( ptc(ji,jj,jl) - ( zfu_ho(ji,jj,jl) - zfu_ho(ji-1,jj,jl) ) * pdt * r1_e1e2t(ji,jj)  &
+                     &                            - ( zfv_ho(ji,jj,jl) - zfv_ho(ji,jj-1,jl) ) * pdt * r1_e1e2t(ji,jj)  ) * tmask(ji,jj,1)
+                  IF( zpt(ji,jj,jl) < 0. ) THEN
+                     zfu_ho(ji  ,jj,jl) = zfu_ups(ji  ,jj,jl)
+                     zfu_ho(ji-1,jj,jl) = zfu_ups(ji-1,jj,jl)
+                     zfv_ho(ji  ,jj,jl) = zfv_ups(ji  ,jj,jl)
+                     zfv_ho(ji,jj-1,jl) = zfv_ups(ji,jj-1,jl)
+                  ENDIF
+               END DO
+            END DO
+         END DO
+         CALL lbc_lnk_multi( 'icedyn_adv_umx', zfu_ho, 'U',  -1., zfv_ho, 'V',  -1. )
+      ENDIF
+
+      ! output high order fluxes u*a
+      ! ----------------------------
+      IF( PRESENT( pua_ho ) ) THEN
+         DO jl = 1, jpl
             DO jj = 1, jpjm1
-               DO ji = 1, fs_jpim1   ! vector opt.
-                  zfu_ho(ji,jj,jl) = 0.5 * puc(ji,jj) * ( ptc(ji,jj,jl) + ptc(ji+1,jj,jl) )
-                  zfv_ho(ji,jj,jl) = 0.5 * pvc(ji,jj) * ( ptc(ji,jj,jl) + ptc(ji,jj+1,jl) )
-               END DO
-            END DO
-         END DO
-         !
-      CASE ( 1:5 )                      ! 1st to 5th order ULTIMATE-MACHO scheme
-         CALL macho( k_order, kt, ipl, pdt, ptc, puc, pvc, pubox, pvbox, zt_u, zt_v )
-         !
-         DO jl = 1, ipl
+               DO ji = 1, fs_jpim1
+                  pua_ho(ji,jj,jl) = zfu_ho(ji,jj,jl)
+                  pva_ho(ji,jj,jl) = zfv_ho(ji,jj,jl)
+               END DO
+            END DO
+         END DO
+      ENDIF
+
+
+      IF( .NOT.ll_thickness ) THEN
+         ! final trend with corrected fluxes
+         ! ------------------------------------
+         DO jl = 1, jpl
             DO jj = 2, jpjm1
-               DO ji = 1, fs_jpim1   ! vector opt.
-                  zfu_ho(ji,jj,jl) = puc(ji,jj) * zt_u(ji,jj,jl)
-               END DO
-            END DO
-         END DO
-         DO jl = 1, ipl
+               DO ji = fs_2, fs_jpim1 
+                  ztra = - ( zfu_ho(ji,jj,jl) - zfu_ho(ji-1,jj,jl) + zfv_ho(ji,jj,jl) - zfv_ho(ji,jj-1,jl) ) * r1_e1e2t(ji,jj) * pdt  
+                  
+                  ptc(ji,jj,jl) = ( ptc(ji,jj,jl) + ztra ) * tmask(ji,jj,1)
+                  
+                  !!               IF( ji==26 .AND. jj==86) THEN
+                  !!                  WRITE(numout,*) 'ztc high order',ptc(ji,jj)
+                  !!               ENDIF
+                  
+               END DO
+            END DO
+         END DO
+         CALL lbc_lnk( 'icedyn_adv_umx', ptc, 'T',  1. )
+      ENDIF
+      
+      !
+   END SUBROUTINE adv_umx
+
+   SUBROUTINE cen2( pamsk, kn_limiter, jt, kt, pdt, pt, pu, pv, puc, pvc, ptc, pfu_ho, pfv_ho, &
+      &             pt_ups, pfu_ups, pfv_ups )
+      !!---------------------------------------------------------------------
+      !!                    ***  ROUTINE macho  ***
+      !!     
+      !! **  Purpose :   compute  
+      !!
+      !! **  Method  :   ... ???
+      !!                 TIM = transient interpolation Modeling 
+      !!
+      !! Reference : Leonard, B.P., 1991, Comput. Methods Appl. Mech. Eng., 88, 17-74. 
+      !!----------------------------------------------------------------------
+      REAL(wp)                    , INTENT(in   ) ::   pamsk            ! advection of concentration (1) or other tracers (0)
+      INTEGER                     , INTENT(in   ) ::   kn_limiter       ! limiter
+      INTEGER                     , INTENT(in   ) ::   jt               ! number of sub-iteration
+      INTEGER                     , INTENT(in   ) ::   kt               ! number of iteration
+      REAL(wp)                    , INTENT(in   ) ::   pdt              ! tracer time-step
+      REAL(wp), DIMENSION(:,:,:), INTENT(in   ) ::   pt               ! tracer fields
+      REAL(wp), DIMENSION(:,:  ), INTENT(in   ) ::   pu, pv           ! 2 ice velocity components
+      REAL(wp), DIMENSION(:,:,:), INTENT(in   ) ::   puc, pvc         ! 2 ice velocity * A components
+      REAL(wp), DIMENSION(:,:,:), INTENT(in   ) ::   ptc              ! tracer content at before time step 
+      REAL(wp), DIMENSION(jpi,jpj,jpl), INTENT(  out) ::   pfu_ho, pfv_ho   ! high order fluxes 
+      REAL(wp), DIMENSION(:,:,:), INTENT(in   ) ::   pt_ups           ! upstream guess of tracer content 
+      REAL(wp), DIMENSION(:,:,:), INTENT(inout) ::   pfu_ups, pfv_ups ! upstream fluxes 
+      !
+      INTEGER  ::   ji, jj, jl    ! dummy loop indices
+      LOGICAL  ::   ll_xy = .TRUE.
+      REAL(wp), DIMENSION(jpi,jpj,jpl) ::   zzt
+      !!----------------------------------------------------------------------
+      !
+      IF( .NOT.ll_xy ) THEN   !-- no alternate directions --!
+         !
+         DO jl = 1, jpl
             DO jj = 1, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  zfv_ho(ji,jj,jl) = pvc(ji,jj) * zt_v(ji,jj,jl)
-               END DO
-            END DO
-         END DO
-         !
-      END SELECT
+               DO ji = 1, fs_jpim1
+                  IF( ll_clem ) THEN
+                     pfu_ho(ji,jj,jl) = 0.5 * pu(ji,jj) * ( pt(ji,jj,jl) + pt(ji+1,jj,jl) )
+                     pfv_ho(ji,jj,jl) = 0.5 * pv(ji,jj) * ( pt(ji,jj,jl) + pt(ji,jj+1,jl) )
+                  ELSE
+                     pfu_ho(ji,jj,jl) = 0.5 * puc(ji,jj,jl) * ( pt(ji,jj,jl) + pt(ji+1,jj,jl) )
+                     pfv_ho(ji,jj,jl) = 0.5 * pvc(ji,jj,jl) * ( pt(ji,jj,jl) + pt(ji,jj+1,jl) )
+                  ENDIF
+               END DO
+            END DO
+         END DO
+         IF    ( kn_limiter == 1 ) THEN
+            IF( ll_clem ) THEN
+               CALL nonosc_2d( pamsk, pdt, pu, puc, pv, pvc, ptc, pt, pt_ups, pfu_ups, pfv_ups, pfu_ho, pfv_ho )
+            ELSE
+               CALL nonosc_2d( pamsk, pdt, pu, puc, pv, pvc, ptc, ptc, pt_ups, pfu_ups, pfv_ups, pfu_ho, pfv_ho )
+            ENDIF
+         ELSEIF( kn_limiter == 2 ) THEN
+            CALL limiter_x( pdt, pu, puc, pt, pfu_ho )
+            CALL limiter_y( pdt, pv, pvc, pt, pfv_ho )
+         ELSEIF( kn_limiter == 3 ) THEN
+            CALL limiter_x( pdt, pu, puc, pt, pfu_ho, pfu_ups )
+            CALL limiter_y( pdt, pv, pvc, pt, pfv_ho, pfv_ups )
+         ENDIF
+         !
+      ELSE                    !-- alternate directions --!
+         !
+         IF( MOD( (kt - 1) / nn_fsbc , 2 ) ==  MOD( (jt - 1) , 2 ) ) THEN   !==  odd ice time step:  adv_x then adv_y  ==!
+            !
+            ! flux in x-direction
+            DO jl = 1, jpl
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1
+                     IF( ll_clem ) THEN
+                        pfu_ho(ji,jj,jl) = 0.5 * pu(ji,jj) * ( pt(ji,jj,jl) + pt(ji+1,jj,jl) )
+                     ELSE
+                        pfu_ho(ji,jj,jl) = 0.5 * puc(ji,jj,jl) * ( pt(ji,jj,jl) + pt(ji+1,jj,jl) )
+                     ENDIF
+                  END DO
+               END DO
+            END DO
+            IF( kn_limiter == 2 )   CALL limiter_x( pdt, pu, puc, pt, pfu_ho )
+            IF( kn_limiter == 3 )   CALL limiter_x( pdt, pu, puc, pt, pfu_ho, pfu_ups )
+
+            ! first guess of tracer content from u-flux
+            DO jl = 1, jpl
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     IF( ll_clem ) THEN
+                        zzt(ji,jj,jl) = ( pt(ji,jj,jl) - ( pfu_ho(ji,jj,jl) - pfu_ho(ji-1,jj,jl) ) * pdt * r1_e1e2t(ji,jj)        &
+                           &            + pt(ji,jj,jl) * pdt * ( pu(ji,jj) - pu(ji-1,jj) ) * r1_e1e2t(ji,jj) * (1.-pamsk) ) &
+                           &         * tmask(ji,jj,1)
+                     ELSE                     
+                        zzt(ji,jj,jl) = ( ptc(ji,jj,jl) - ( pfu_ho(ji,jj,jl) - pfu_ho(ji-1,jj,jl) ) * pdt * r1_e1e2t(ji,jj) ) * tmask(ji,jj,1)
+                     ENDIF
+                  END DO
+               END DO
+            END DO
+            CALL lbc_lnk( 'icedyn_adv_umx', zzt, 'T', 1. )
+
+            ! flux in y-direction
+            DO jl = 1, jpl
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1
+                     IF( ll_clem ) THEN
+                        pfv_ho(ji,jj,jl) = 0.5 * pv(ji,jj) * ( zzt(ji,jj,jl) + zzt(ji,jj+1,jl) )
+                     ELSE                     
+                        pfv_ho(ji,jj,jl) = 0.5 * pvc(ji,jj,jl) * ( zzt(ji,jj,jl) + zzt(ji,jj+1,jl) )
+                     ENDIF
+                  END DO
+               END DO
+            END DO
+            IF( kn_limiter == 2 )   CALL limiter_y( pdt, pv, pvc, pt, pfv_ho )
+            IF( kn_limiter == 3 )   CALL limiter_y( pdt, pv, pvc, pt, pfv_ho, pfv_ups )
+
+         ELSE                                                               !==  even ice time step:  adv_y then adv_x  ==!
+            !
+            ! flux in y-direction
+            DO jl = 1, jpl
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1
+                     IF( ll_clem ) THEN
+                        pfv_ho(ji,jj,jl) = 0.5 * pv(ji,jj) * ( pt(ji,jj,jl) + pt(ji,jj+1,jl) )
+                     ELSE                     
+                        pfv_ho(ji,jj,jl) = 0.5 * pvc(ji,jj,jl) * ( pt(ji,jj,jl) + pt(ji,jj+1,jl) )
+                     ENDIF
+                  END DO
+               END DO
+            END DO
+            IF( kn_limiter == 2 )   CALL limiter_y( pdt, pv, pvc, pt, pfv_ho )
+            IF( kn_limiter == 3 )   CALL limiter_y( pdt, pv, pvc, pt, pfv_ho, pfv_ups )
+            !
+            ! first guess of tracer content from v-flux
+            DO jl = 1, jpl
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     IF( ll_clem ) THEN
+                        zzt(ji,jj,jl) = ( pt(ji,jj,jl) - ( pfv_ho(ji,jj,jl) - pfv_ho(ji,jj-1,jl) ) * pdt * r1_e1e2t(ji,jj) &
+                           &                     + pt(ji,jj,jl) * pdt * ( pv(ji,jj) - pv(ji,jj-1) ) * r1_e1e2t(ji,jj) * (1.-pamsk) ) &
+                           &         * tmask(ji,jj,1)
+                     ELSE
+                        zzt(ji,jj,jl) = ( ptc(ji,jj,jl) - ( pfv_ho(ji,jj,jl) - pfv_ho(ji,jj-1,jl) ) * pdt * r1_e1e2t(ji,jj) ) * tmask(ji,jj,1)
+                     ENDIF
+                  END DO
+               END DO
+            END DO
+            CALL lbc_lnk( 'icedyn_adv_umx', zzt, 'T', 1. )
+            !
+            ! flux in x-direction
+            DO jl = 1, jpl
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1
+                     IF( ll_clem ) THEN
+                        pfu_ho(ji,jj,jl) = 0.5 * pu(ji,jj) * ( zzt(ji,jj,jl) + zzt(ji+1,jj,jl) )
+                     ELSE
+                        pfu_ho(ji,jj,jl) = 0.5 * puc(ji,jj,jl) * ( zzt(ji,jj,jl) + zzt(ji+1,jj,jl) )
+                     ENDIF
+                  END DO
+               END DO
+            END DO
+            IF( kn_limiter == 2 )   CALL limiter_x( pdt, pu, puc, pt, pfu_ho )
+            IF( kn_limiter == 3 )   CALL limiter_x( pdt, pu, puc, pt, pfu_ho, pfu_ups )
+
+         ENDIF
+         IF( ll_clem ) THEN
+            IF( kn_limiter == 1 )   CALL nonosc_2d( pamsk, pdt, pu, puc, pv, pvc, ptc, pt, pt_ups, pfu_ups, pfv_ups, pfu_ho, pfv_ho )
+         ELSE
+            IF( kn_limiter == 1 )   CALL nonosc_2d( pamsk, pdt, pu, puc, pv, pvc, ptc, ptc, pt_ups, pfu_ups, pfv_ups, pfu_ho, pfv_ho )
+         ENDIF
          
-      ! antidiffusive flux : high order minus low order
-      ! --------------------------------------------------
-      DO jl = 1, ipl
-         DO jj = 2, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
-               zfu_ho(ji,jj,jl) = zfu_ho(ji,jj,jl) - zfu_ups(ji,jj,jl)
-            END DO
-         END DO
-      END DO
-      DO jl = 1, ipl
-         DO jj = 1, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               zfv_ho(ji,jj,jl) = zfv_ho(ji,jj,jl) - zfv_ups(ji,jj,jl)
-            END DO
-         END DO
-      END DO
-
-      CALL lbc_lnk("icedyn_adv_umx",zt_ups, 'T', 1. )        ! Lateral boundary conditions   (unchanged sign)
-      
-      ! monotonicity algorithm
-      ! -------------------------
-      CALL nonosc_2d( ipl, ptc, zfu_ho, zfv_ho, zt_ups, pdt )
-      
-      ! final trend with corrected fluxes
-      ! ------------------------------------
-      DO jl = 1, ipl
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.  
-               ztra       = ztrd(ji,jj,jl)  - (  zfu_ho(ji,jj,jl) - zfu_ho(ji-1,jj  ,jl)   &
-                  &                         +    zfv_ho(ji,jj,jl) - zfv_ho(ji  ,jj-1,jl) ) * r1_e1e2t(ji,jj)  
-               ptc(ji,jj,jl) = ptc(ji,jj,jl) + pdt * ztra * tmask(ji,jj,1)
-            END DO
-         END DO
-      END DO
-      !
-   END SUBROUTINE adv_umx
-
-   SUBROUTINE macho( k_order, kt, ipl, pdt, ptc, puc, pvc, pubox, pvbox, pt_u, pt_v )
+      ENDIF
+   
+   END SUBROUTINE cen2
+
+   
+   SUBROUTINE macho( pamsk, kn_limiter, kn_umx, jt, kt, pdt, pt, pu, pv, puc, pvc, pubox, pvbox, ptc, pt_u, pt_v, pfu_ho, pfv_ho, &
+      &              pt_ups, pfu_ups, pfv_ups )
+      !!---------------------------------------------------------------------
+      !!                    ***  ROUTINE macho  ***
+      !!     
+      !! **  Purpose :   compute  
+      !!
+      !! **  Method  :   ... ???
+      !!                 TIM = transient interpolation Modeling 
+      !!
+      !! Reference : Leonard, B.P., 1991, Comput. Methods Appl. Mech. Eng., 88, 17-74. 
+      !!----------------------------------------------------------------------
+      REAL(wp)                    , INTENT(in   ) ::   pamsk            ! advection of concentration (1) or other tracers (0)
+      INTEGER                     , INTENT(in   ) ::   kn_limiter       ! limiter
+      INTEGER                     , INTENT(in   ) ::   kn_umx           ! order of the scheme (1-5=UM or 20=CEN2)
+      INTEGER                     , INTENT(in   ) ::   jt               ! number of sub-iteration
+      INTEGER                     , INTENT(in   ) ::   kt               ! number of iteration
+      REAL(wp)                    , INTENT(in   ) ::   pdt              ! tracer time-step
+      REAL(wp), DIMENSION(:,:,:), INTENT(in   ) ::   pt               ! tracer fields
+      REAL(wp), DIMENSION(:,:  ), INTENT(in   ) ::   pu, pv           ! 2 ice velocity components
+      REAL(wp), DIMENSION(:,:,:), INTENT(in   ) ::   puc, pvc         ! 2 ice velocity * A components
+      REAL(wp), DIMENSION(:,:  ), INTENT(in   ) ::   pubox, pvbox     ! upstream velocity
+      REAL(wp), DIMENSION(:,:,:), INTENT(in   ) ::   ptc              ! tracer content at before time step 
+      REAL(wp), DIMENSION(jpi,jpj,jpl), INTENT(  out) ::   pt_u, pt_v       ! tracer at u- and v-points 
+      REAL(wp), DIMENSION(jpi,jpj,jpl), INTENT(  out) ::   pfu_ho, pfv_ho   ! high order fluxes 
+      REAL(wp), DIMENSION(:,:,:), INTENT(in   ) ::   pt_ups           ! upstream guess of tracer content 
+      REAL(wp), DIMENSION(:,:,:), INTENT(inout) ::   pfu_ups, pfv_ups ! upstream fluxes 
+      !
+      INTEGER  ::   ji, jj, jl    ! dummy loop indices
+      REAL(wp) ::   ztra
+      REAL(wp), DIMENSION(jpi,jpj,jpl) ::   zzt, zzfu_ho, zzfv_ho
+      !!----------------------------------------------------------------------
+      !
+      IF( MOD( (kt - 1) / nn_fsbc , 2 ) ==  MOD( (jt - 1) , 2 ) ) THEN   !==  odd ice time step:  adv_x then adv_y  ==!
+         !
+         !                                                        !--  ultimate interpolation of pt at u-point  --!
+         CALL ultimate_x( kn_umx, pdt, pt, pu, puc, pt_u, pfu_ho )
+         !                                                        !--  limiter in x --!
+         IF( kn_limiter == 2 )   CALL limiter_x( pdt, pu, puc, pt, pfu_ho )
+         IF( kn_limiter == 3 )   CALL limiter_x( pdt, pu, puc, pt, pfu_ho, pfu_ups )
+         !                                                        !--  advective form update in zzt  --!
+
+         IF( ll_1stguess_clem ) THEN
+
+            ! first guess of tracer content from u-flux
+            DO jl = 1, jpl
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     IF( ll_clem ) THEN
+                        IF( ll_gurvan ) THEN
+                           zzt(ji,jj,jl) = ( pt(ji,jj,jl) - ( pfu_ho(ji,jj,jl) - pfu_ho(ji-1,jj,jl) ) * pdt * r1_e1e2t(ji,jj) ) * tmask(ji,jj,1)
+                        ELSE
+                           zzt(ji,jj,jl) = ( pt(ji,jj,jl) - ( pfu_ho(ji,jj,jl) - pfu_ho(ji-1,jj,jl) ) * pdt * r1_e1e2t(ji,jj)  &
+                              &            + pt(ji,jj,jl) * pdt * ( pu(ji,jj) - pu(ji-1,jj) ) * r1_e1e2t(ji,jj) * (1.-pamsk) &
+                              &         ) * tmask(ji,jj,1)
+                        ENDIF
+                     ELSE
+                        zzt(ji,jj,jl) = ( ptc(ji,jj,jl) - ( pfu_ho(ji,jj,jl) - pfu_ho(ji-1,jj,jl) ) * pdt * r1_e1e2t(ji,jj) ) * tmask(ji,jj,1)
+                     ENDIF
+                  END DO
+               END DO
+            END DO
+            CALL lbc_lnk( 'icedyn_adv_umx', zzt, 'T', 1. )
+
+         ELSE
+
+            DO jl = 1, jpl
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     IF( ll_gurvan ) THEN
+                        zzt(ji,jj,jl) = pt(ji,jj,jl) - pubox(ji,jj   ) * pdt * ( pt_u(ji,jj,jl) - pt_u(ji-1,jj,jl) ) * r1_e1t(ji,jj)  &
+                           &                         - pt   (ji,jj,jl) * pdt * ( pu  (ji,jj) - pu  (ji-1,jj) ) * r1_e1e2t(ji,jj)
+                     ELSE
+                        zzt(ji,jj,jl) = pt(ji,jj,jl) - pubox(ji,jj   ) * pdt * ( pt_u(ji,jj,jl) - pt_u(ji-1,jj,jl) ) * r1_e1t(ji,jj)  &
+                           &                         - pt   (ji,jj,jl) * pdt * ( pu  (ji,jj) - pu  (ji-1,jj) ) * r1_e1e2t(ji,jj) * pamsk
+                     ENDIF
+                     zzt(ji,jj,jl) = zzt(ji,jj,jl) * tmask(ji,jj,1)
+                  END DO
+               END DO
+            END DO
+            CALL lbc_lnk( 'icedyn_adv_umx', zzt, 'T', 1. )
+         ENDIF
+         !
+         !                                                        !--  ultimate interpolation of pt at v-point  --!
+         IF( ll_hoxy ) THEN
+            CALL ultimate_y( kn_umx, pdt, zzt, pv, pvc, pt_v, pfv_ho )
+         ELSE
+            CALL ultimate_y( kn_umx, pdt, pt, pv, pvc, pt_v, pfv_ho )
+         ENDIF
+         !                                                        !--  limiter in y --!
+         IF( kn_limiter == 2 )   CALL limiter_y( pdt, pv, pvc, pt, pfv_ho )
+         IF( kn_limiter == 3 )   CALL limiter_y( pdt, pv, pvc, pt, pfv_ho, pfv_ups )
+         !         
+         !
+      ELSE                                                               !==  even ice time step:  adv_y then adv_x  ==!
+         !
+         !                                                        !--  ultimate interpolation of pt at v-point  --!
+         CALL ultimate_y( kn_umx, pdt, pt, pv, pvc, pt_v, pfv_ho )
+         !                                                        !--  limiter in y --!
+         IF( kn_limiter == 2 )   CALL limiter_y( pdt, pv, pvc, pt, pfv_ho )
+         IF( kn_limiter == 3 )   CALL limiter_y( pdt, pv, pvc, pt, pfv_ho, pfv_ups )
+         !                                                        !--  advective form update in zzt  --!
+         IF( ll_1stguess_clem ) THEN
+            
+            ! first guess of tracer content from v-flux 
+            DO jl = 1, jpl
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     IF( ll_clem ) THEN
+                        IF( ll_gurvan ) THEN
+                           zzt(ji,jj,jl) = ( pt(ji,jj,jl) - ( pfv_ho(ji,jj,jl) - pfv_ho(ji,jj-1,jl) ) * pdt * r1_e1e2t(ji,jj) ) * tmask(ji,jj,1)
+                        ELSE
+                           zzt(ji,jj,jl) = ( pt(ji,jj,jl) - ( pfv_ho(ji,jj,jl) - pfv_ho(ji,jj-1,jl) ) * pdt * r1_e1e2t(ji,jj) &
+                              &            + pt(ji,jj,jl) * pdt * ( pv(ji,jj) - pv(ji,jj-1) ) * r1_e1e2t(ji,jj) * (1.-pamsk) &
+                              &         ) * tmask(ji,jj,1)
+                        ENDIF
+                     ELSE
+                        zzt(ji,jj,jl) = ( ptc(ji,jj,jl) - ( pfv_ho(ji,jj,jl) - pfv_ho(ji,jj-1,jl) ) * pdt * r1_e1e2t(ji,jj) ) &
+                           &         * tmask(ji,jj,1)
+                     ENDIF
+                  END DO
+               END DO
+            END DO
+            CALL lbc_lnk( 'icedyn_adv_umx', zzt, 'T', 1. )
+            
+         ELSE
+            
+            DO jl = 1, jpl
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1
+                     IF( ll_gurvan ) THEN
+                        zzt(ji,jj,jl) = pt(ji,jj,jl) - pvbox(ji,jj   ) * pdt * ( pt_v(ji,jj,jl) - pt_v(ji,jj-1,jl) ) * r1_e2t(ji,jj)  &
+                           &                         - pt   (ji,jj,jl) * pdt * ( pv  (ji,jj) - pv  (ji,jj-1) ) * r1_e1e2t(ji,jj)
+                     ELSE
+                        zzt(ji,jj,jl) = pt(ji,jj,jl) - pvbox(ji,jj   ) * pdt * ( pt_v(ji,jj,jl) - pt_v(ji,jj-1,jl) ) * r1_e2t(ji,jj)  &
+                           &                         - pt   (ji,jj,jl) * pdt * ( pv  (ji,jj) - pv  (ji,jj-1) ) * r1_e1e2t(ji,jj) * pamsk
+                     ENDIF
+                     zzt(ji,jj,jl) = zzt(ji,jj,jl) * tmask(ji,jj,1)
+                  END DO
+               END DO
+            END DO
+            CALL lbc_lnk( 'icedyn_adv_umx', zzt, 'T', 1. )
+         ENDIF
+         !
+         !                                                        !--  ultimate interpolation of pt at u-point  --!
+         IF( ll_hoxy ) THEN
+            CALL ultimate_x( kn_umx, pdt, zzt, pu, puc, pt_u, pfu_ho )
+         ELSE
+            CALL ultimate_x( kn_umx, pdt, pt, pu, puc, pt_u, pfu_ho )
+         ENDIF
+         !                                                        !--  limiter in x --!
+         IF( kn_limiter == 2 )   CALL limiter_x( pdt, pu, puc, pt, pfu_ho )
+         IF( kn_limiter == 3 )   CALL limiter_x( pdt, pu, puc, pt, pfu_ho, pfu_ups )
+         !
+         !
+      ENDIF
+
+     
+      IF( kn_limiter == 1 ) THEN
+         IF( .NOT. ll_limiter_it2 ) THEN
+            IF( ll_clem ) THEN
+               CALL nonosc_2d ( pamsk, pdt, pu, puc, pv, pvc, ptc, pt, pt_ups, pfu_ups, pfv_ups, pfu_ho, pfv_ho )
+            ELSE
+               CALL nonosc_2d ( pamsk, pdt, pu, puc, pv, pvc, ptc, ptc, pt_ups, pfu_ups, pfv_ups, pfu_ho, pfv_ho )
+            ENDIF
+         ELSE
+            zzfu_ho(:,:,:) = pfu_ho(:,:,:)
+            zzfv_ho(:,:,:) = pfv_ho(:,:,:)
+            ! 1st iteration of nonosc (limit the flux with the upstream solution)
+            IF( ll_clem ) THEN
+               CALL nonosc_2d ( pamsk, pdt, pu, puc, pv, pvc, ptc, pt, pt_ups, pfu_ups, pfv_ups, zzfu_ho, zzfv_ho )
+            ELSE
+               CALL nonosc_2d ( pamsk, pdt, pu, puc, pv, pvc, ptc, ptc, pt_ups, pfu_ups, pfv_ups, zzfu_ho, zzfv_ho )
+            ENDIF
+            ! guess after content field with high order
+            DO jl = 1, jpl
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1
+                     ztra          = - ( zzfu_ho(ji,jj,jl) - zzfu_ho(ji-1,jj,jl) + zzfv_ho(ji,jj,jl) - zzfv_ho(ji,jj-1,jl) ) * r1_e1e2t(ji,jj)
+                     zzt(ji,jj,jl) =   ( ptc(ji,jj,jl) + pdt * ztra ) * tmask(ji,jj,1)
+                  END DO
+               END DO
+            END DO
+            CALL lbc_lnk( 'icedyn_adv_umx', zzt, 'T', 1. )
+            ! 2nd iteration of nonosc (limit the flux with the limited high order solution)
+            IF( ll_clem ) THEN
+               CALL nonosc_2d ( pamsk, pdt, pu, puc, pv, pvc, ptc, pt, zzt, zzfu_ho, zzfv_ho, pfu_ho, pfv_ho )
+            ELSE
+               CALL nonosc_2d ( pamsk, pdt, pu, puc, pv, pvc, ptc, ptc, zzt, zzfu_ho, zzfv_ho, pfu_ho, pfv_ho )
+            ENDIF
+         ENDIF
+      ENDIF
+      !
+   END SUBROUTINE macho
+
+
+   SUBROUTINE ultimate_x( kn_umx, pdt, pt, pu, puc, pt_u, pfu_ho )
       !!---------------------------------------------------------------------
       !!                    ***  ROUTINE ultimate_x  ***
